!!NVgp4.0

# cubic b-spline curve geometry program

PRIMITIVE_IN LINES_ADJACENCY;
PRIMITIVE_OUT LINE_STRIP;
VERTICES_OUT 100;

PARAM segments = program.local[0];
PARAM basis0 = { 1, -3, 3, -1 };  # basis matrix
PARAM basis1 = { 4, 0, -6, 3 };
PARAM basis2 = { 1, 3, 3, -3 };
PARAM basis3 = { 0, 0, 0, 1 };

TEMP pos, t, dt, temp, b;

DIV dt.x, 1.0, segments.x;
MOV t.x, 1.0;
MOV t.y, 0.0;

ADD temp.x, segments.x, 1;
REP temp.x;

# (1, t, t^2, t^3)
MUL t.z, t.y, t.y;
MUL t.w, t.z, t.y;

# Calculate blending function
DP4 b.x, t, basis0;
DP4 b.y, t, basis1;
DP4 b.z, t, basis2;
DP4 b.w, t, basis3;
DIV b, b, 6;        # should bake this into the basis matrix

# evaluate curve
MUL pos, vertex[0].position, b.x;
MAD pos, vertex[1].position, b.y, pos;
MAD pos, vertex[2].position, b.z, pos;
MAD pos, vertex[3].position, b.w, pos;

MOV result.color.x, t.y;
MOV result.position, pos;

EMIT;

ADD t.y, t.y, dt.x;
ENDREP;

END