!!NVgp4.0

# geometry program for outputing fins

PRIMITIVE_IN TRIANGLES;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 15;

ATTRIB v0 = vertex[0].position;
ATTRIB v1 = vertex[1].position;
ATTRIB v2 = vertex[2].position;
ATTRIB normal0 = vertex[0].texcoord[1];
ATTRIB normal1 = vertex[1].texcoord[1];
ATTRIB normal2 = vertex[2].texcoord[1];
PARAM mvp[4] = { state.matrix.mvp };
PARAM scale = 0.2;
PARAM finColor = { 1, 0, 0, 1 };
TEMP f0, f1, f2;
TEMP ov0, ov1, ov2, of0, of1, of2;

MOV f0, v0;
MOV f1, v1;
MOV f2, v2;
MAD f0.xyz, normal0, scale, v0;
MAD f1.xyz, normal1, scale, v1;
MAD f2.xyz, normal2, scale, v2;

#compute the transformed positions
DP4 ov0.x, mvp[0], v0; 
DP4 ov0.y, mvp[1], v0; 
DP4 ov0.z, mvp[2], v0; 
DP4 ov0.w, mvp[3], v0;

DP4 ov1.x, mvp[0], v1; 
DP4 ov1.y, mvp[1], v1; 
DP4 ov1.z, mvp[2], v1; 
DP4 ov1.w, mvp[3], v1;

DP4 ov2.x, mvp[0], v2; 
DP4 ov2.y, mvp[1], v2; 
DP4 ov2.z, mvp[2], v2; 
DP4 ov2.w, mvp[3], v2;

DP4 of0.x, mvp[0], f0; 
DP4 of0.y, mvp[1], f0; 
DP4 of0.z, mvp[2], f0; 
DP4 of0.w, mvp[3], f0;

DP4 of1.x, mvp[0], f1; 
DP4 of1.y, mvp[1], f1; 
DP4 of1.z, mvp[2], f1; 
DP4 of1.w, mvp[3], f1;

DP4 of2.x, mvp[0], f2; 
DP4 of2.y, mvp[1], f2; 
DP4 of2.z, mvp[2], f2; 
DP4 of2.w, mvp[3], f2;


# original tri
MOV result.color, vertex[0].color; 
MOV result.position, ov0;
EMIT;

MOV result.color, vertex[1].color; 
MOV result.position, ov1;
EMIT;

MOV result.color, vertex[2].color; 
MOV result.position, ov2;
EMIT;
ENDPRIM;

# fins
MOV result.color, finColor; 
MOV result.position, of0; 
EMIT;

MOV result.color, finColor; 
MOV result.position, of1;
EMIT;

MOV result.color, finColor; 
MOV result.position, ov0;
EMIT;

MOV result.color, finColor; 
MOV result.position, ov1;
EMIT;
ENDPRIM;


MOV result.color, finColor; 
MOV result.position, of1; 
EMIT;

MOV result.color, finColor; 
MOV result.position, of2; 
EMIT;

MOV result.color, finColor; 
MOV result.position, ov1; 
EMIT;

MOV result.color, finColor; 
MOV result.position, ov2; 
EMIT;
ENDPRIM;


MOV result.color, finColor; 
MOV result.position, of2; 
EMIT;

MOV result.color, finColor; 
MOV result.position, of0; 
EMIT;

MOV result.color, finColor; 
MOV result.position, ov2; 
EMIT;

MOV result.color, finColor; 
MOV result.position, ov0; 
EMIT;
ENDPRIM;

END