!!NVgp4.0

# filled quadratic bezier curve geometry program

PRIMITIVE_IN TRIANGLES;
#PRIMITIVE_OUT LINE_STRIP;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 100;

PARAM segments = program.local[0];
PARAM mvp[4] = { state.matrix.mvp };
TEMP pos, t, dt, temp;
TEMP omt, b, prev, origin;

DIV dt.x, 1.0, segments.x;
MOV t.x, 0.0;
ADD temp.x, segments.x, 1;
MOV prev, vertex[0].position;

ADD origin, vertex[0].position, vertex[1].position;
MUL origin, origin, 0.5;

REP temp.x;

# Calculate quadratic Bernstein blending functions:
# B0(t) = (1-t)^2	
# B1(t) = 2t(1-t)
# B2(t) = t^2
ADD omt.x, 1.0, -t.x;		# omt = 1-t
MUL b.x, omt.x, omt.x;      # B0 = (1-t)^2
MUL temp.x, 2.0, t.x;	    # temp = 2*t
MUL b.y, temp.x, omt.x;     # B1 = 2*t*(1-t)
MUL b.z, t.x, t.x;	        # B2 = t*t

# evaluate curve
MUL pos, vertex[0].position, b.x;
MAD pos, vertex[2].position, b.y, pos;
MAD pos, vertex[1].position, b.z, pos;

#MOV result.position, pos;
#EMIT;

MOV result.color, 0;
MOV result.position, origin;
EMIT;
MOV result.color, 0;
MOV result.color.x, t.x;
MOV result.position, prev;
EMIT;
MOV result.color.yzw, 0;
MOV result.color.x, t.x;
MOV result.position, pos;
EMIT;
ENDPRIM;

MOV prev, pos;

ADD t, t, dt;
ENDREP;

END