!!NVgp4.0

# reflect triangle (idea from M.Sainz)
#  outputs the triangle and a reflected copy in a single pass

# set the GS environment
PRIMITIVE_IN TRIANGLES;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 6;

PARAM mvp[4] = { state.matrix.mvp };
PARAM scale = { 1.0, 1.0, -1.0, 1.0 };
PARAM translate = { 0.0, 0.0, 0.0, 0.0 };
TEMP pos;

# output original triangle
MOV result.color, vertex[0].color;
DP4 result.position.x, mvp[0], vertex[0].position;
DP4 result.position.y, mvp[1], vertex[0].position;
DP4 result.position.z, mvp[2], vertex[0].position;
DP4 result.position.w, mvp[3], vertex[0].position;
EMIT;

MOV result.color, vertex[1].color;
DP4 result.position.x, mvp[0], vertex[1].position;
DP4 result.position.y, mvp[1], vertex[1].position;
DP4 result.position.z, mvp[2], vertex[1].position;
DP4 result.position.w, mvp[3], vertex[1].position;
EMIT;

MOV result.color, vertex[2].color;
DP4 result.position.x, mvp[0], vertex[2].position;
DP4 result.position.y, mvp[1], vertex[2].position;
DP4 result.position.z, mvp[2], vertex[2].position;
DP4 result.position.w, mvp[3], vertex[2].position;
EMIT;
ENDPRIM;

# output reflected triangle
MUL pos, vertex[0].position, scale;
ADD pos, pos, translate;
MOV result.color, vertex[0].color;
DP4 result.position.x, mvp[0], pos;
DP4 result.position.y, mvp[1], pos;
DP4 result.position.z, mvp[2], pos;
DP4 result.position.w, mvp[3], pos;
EMIT;

MUL pos, vertex[1].position, scale;
ADD pos, pos, translate;
MOV result.color, vertex[1].color;
DP4 result.position.x, mvp[0], pos;
DP4 result.position.y, mvp[1], pos;
DP4 result.position.z, mvp[2], pos;
DP4 result.position.w, mvp[3], pos;
EMIT;

MUL pos, vertex[2].position, scale;
ADD pos, pos, translate;
MOV result.color, vertex[2].color;
DP4 result.position.x, mvp[0], pos;
DP4 result.position.y, mvp[1], pos;
DP4 result.position.z, mvp[2], pos;
DP4 result.position.w, mvp[3], pos;
EMIT;

ENDPRIM;

END