!!NVgp4.0

PRIMITIVE_IN TRIANGLES_ADJACENCY;
PRIMITIVE_OUT LINE_STRIP;
VERTICES_OUT 6;

# detect silhouette edges by comparing triangle plane
# and those of the adjacent triangles against the eye
# expects eye space position in vertex.texcoord
# 1-2-3
#  \|\|
#   0-4
#    \|
#     5

TEMP e0, e1, e2;
TEMP e, n, n2, d, eye, eye2;
PARAM eyePos = { 0, 0, 0, 1 };
# calculate edge vectors
SUB e0, vertex[2].texcoord, vertex[0].texcoord;
SUB e1, vertex[4].texcoord, vertex[2].texcoord;
SUB e2, vertex[0].texcoord, vertex[4].texcoord;

# calculate tri normal
XPD n, e0, e1;

# calculate the plane
DP3 n.w, vertex[0].texcoord, -n;
DP4 d.x, n, eye;

# edge 0
# calculate adjacent tri normal
SUB e, vertex[1].texcoord, vertex[0].texcoord;
XPD n2, e0, e;

DP3 n2.w, vertex[0].texcoord, -n2;
DP4 d.y, n2, eye;
MULC d.z, d.x, d.y;

# draw edge if dot product signs are different
IF LE.z;
   MOV result.color, vertex[0].color;
   MOV result.position, vertex[0].position; EMIT;
   MOV result.color, vertex[2].color;
   MOV result.position, vertex[2].position; EMIT;
   ENDPRIM;
ENDIF;

# edge 1
# calculate adjacent tri normal
SUB e, vertex[3].texcoord, vertex[2].texcoord;
XPD n2, e1, e;

DP3 n2.w, vertex[2].texcoord, -n2;
DP4 d.y, n2, eye;
MULC d.z, d.x, d.y;

# draw edge if dot product signs are different
IF LE.z;
   MOV result.color, vertex[2].color;
   MOV result.position, vertex[2].position; EMIT;
   MOV result.color, vertex[4].color;
   MOV result.position, vertex[4].position; EMIT;
   ENDPRIM;
ENDIF;

# edge 2
# calculate adjacent tri normal
SUB e, vertex[5].texcoord, vertex[4].texcoord;
XPD n2, e2, e;

DP3 n2.w, vertex[4].texcoord, -n2;
DP4 d.y, n2, eye;
MULC d.z, d.x, d.y;

# draw edge if dot product signs are different
IF LE.z;
   MOV result.color, vertex[4].color;
   MOV result.position, vertex[4].position; EMIT;
   MOV result.color, vertex[0].color;
   MOV result.position, vertex[0].position; EMIT;
   ENDPRIM;
ENDIF;

END